package T4Chart;
/**
 * <p>Title: Bourse</p>
 * <p>Description: Cours Boursiers</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Patrice Trognon (Freelance)</p>
 * @author Patrice Trognon
 * @version 1.0
 */


import java.sql.ResultSet;
import java.sql.PreparedStatement;
import java.util.Iterator;

/**
 * Iterator over a ResultSet.
 */
abstract class SqlIterator
implements Iterator {
    private PreparedStatement _stmt;
    private ResultSet _rs;
    private boolean   _hasNext;
    
    SqlIterator(PreparedStatement stmt, ResultSet rs) {
        _stmt = stmt;
        _rs = rs;
        try {
            _hasNext = rs.next();
        }
        catch(Exception e) {
            _hasNext = false;
        }
    }
    
    public boolean hasNext() {
        return _hasNext;
    }
    
    public Object next() {
        if(!_hasNext) {
            return null;
        }
        try {
            Object result = createObjectFromRow(_rs);
            _hasNext = _rs.next();
            return result;
        }
        catch(Exception e) {
            // Iterator definition of the method don't include Exception !
            throw new RuntimeException("Nested Exception : " + e.toString());
        }
    }
    
    public void close() {
        try {
            _rs.close();
            _stmt.close();
        }
        catch(Exception e) {
        }
    }
    
    abstract Object createObjectFromRow(ResultSet resultset) throws Exception;
    
    
    public void remove() throws UnsupportedOperationException {
        throw new UnsupportedOperationException();
    }
}
