package T4Chart;
/*
 * T4Chart.java
 *
 * Created on 10 mars 2004, 11:19
 */

import javax.swing.*;
import javax.swing.JComponent.*;
import javax.swing.UIManager;
import javax.swing.event.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.sql.*;
import org.jfree.chart.*;
import org.jfree.data.*;
import org.jfree.ui.ApplicationFrame;
import org.jfree.ui.RefineryUtilities;
import org.jfree.data.time.Second;
/**
 *
 * @author  JF
 */
// public class T4Chart extends javax.swing.JFrame implements T4ChartConstants {
public class T4Chart extends ApplicationFrame implements T4ChartConstants {
    
    private T4ChartVariables commonVariables;
    public static final int MAX_ITEMS = 7;
    // Current ui
    private String _currentUI = UIManager.getLookAndFeel().getName();
    
    // L&F radio buttons
    private JRadioButtonMenuItem _macMenuItem;
    private JRadioButtonMenuItem _metalMenuItem;
    private JRadioButtonMenuItem _motifMenuItem;
    private JRadioButtonMenuItem _windowsMenuItem;
    private javax.swing.JCheckBox[] jcb_items = new javax.swing.JCheckBox[MAX_ITEMS];
    private javax.swing.JComboBox[] cmb_hosts = new javax.swing.JComboBox[MAX_ITEMS + 1];
    private javax.swing.JComboBox[] cmb_tables = new javax.swing.JComboBox[MAX_ITEMS];
    private javax.swing.JComboBox[] cmb_columns = new javax.swing.JComboBox[MAX_ITEMS];
    private javax.swing.JTextField[] jt_timestampStart = new javax.swing.JTextField[2];
    private javax.swing.JTextField[] jt_timestampEnd = new javax.swing.JTextField[2];
    private ToggleUIListener toggleUIListener = new ToggleUIListener();
    private boolean evalMinMax = true;
    private boolean evalMinMaxT2 = true;
    private Vector allTables;
    
    /** Creates new form T4Chart */
    public T4Chart(T4ChartVariables tcv) {
        super("T4Chart");
        commonVariables = tcv;
        initComponents();

        jcb_items[0] = jcb_items0;
        jcb_items[1] = jcb_items1;
        jcb_items[2] = jcb_items2;
        jcb_items[3] = jcb_items3;
        jcb_items[4] = jcb_items4;
        jcb_items[5] = jcb_items5;
        jcb_items[6] = jcb_items6;

        cmb_hosts[0] = cmb_hosts0;
        cmb_hosts[1] = cmb_hosts1;
        cmb_hosts[2] = cmb_hosts2;
        cmb_hosts[3] = cmb_hosts3;
        cmb_hosts[4] = cmb_hosts4;
        cmb_hosts[5] = cmb_hosts5;
        cmb_hosts[6] = cmb_hosts6;
        cmb_hosts[7] = cmb_hosts0T2;

        cmb_tables[0] = cmb_tables0;
        cmb_tables[1] = cmb_tables1;
        cmb_tables[2] = cmb_tables2;
        cmb_tables[3] = cmb_tables3;
        cmb_tables[4] = cmb_tables4;
        cmb_tables[5] = cmb_tables5;
        cmb_tables[6] = cmb_tables6;

        cmb_columns[0] = cmb_columns0;
        cmb_columns[1] = cmb_columns1;
        cmb_columns[2] = cmb_columns2;
        cmb_columns[3] = cmb_columns3;
        cmb_columns[4] = cmb_columns4;
        cmb_columns[5] = cmb_columns5;
        cmb_columns[6] = cmb_columns6;

        jt_timestampStart[0] = jt_timestampStart0;
        jt_timestampStart[1] = jt_timestampStart1;

        jt_timestampEnd[0] = jt_timestampEnd0;
        jt_timestampEnd[1] = jt_timestampEnd1;

        bg_graphType.add(jrb_graphTypeLines);
        bg_graphType.add(jrb_graphTypeAreasStacked);
        bg_graphType.add(jrb_graphTypeDifference);

        bg_graphTypeT2.add(jrb_graphTypeLinesT2);
        bg_graphTypeT2.add(jrb_graphTypeAreasStackedT2);
 
        jrb_java.setSelected(UIManager.getLookAndFeel().getName().equals("Metal"));
        jrb_java.addItemListener(toggleUIListener);
        jrb_macintosh.setSelected(UIManager.getLookAndFeel().getName().equals("Macintosh"));
        jrb_macintosh.addItemListener(toggleUIListener);
        jrb_motif.setSelected(UIManager.getLookAndFeel().getName().equals("Motif"));
        jrb_motif.addItemListener(toggleUIListener);
        jrb_windows.setSelected(UIManager.getLookAndFeel().getName().equals("Windows"));
        jrb_windows.addItemListener(toggleUIListener);
        bg_LookAndFeel.add(jrb_java);
        bg_LookAndFeel.add(jrb_macintosh);
        bg_LookAndFeel.add(jrb_motif);
        bg_LookAndFeel.add(jrb_windows);
        DoConnect();

//        commonVariables.setTextArea(jTextArea1);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        js_timestampMin = new javax.swing.JSlider();
        jft_timestampMin = new javax.swing.JFormattedTextField();
        bg_graphType = new javax.swing.ButtonGroup();
        bg_LookAndFeel = new javax.swing.ButtonGroup();
        bg_graphTypeT2 = new javax.swing.ButtonGroup();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel9 = new javax.swing.JPanel();
        jPanel10 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jPanel11 = new javax.swing.JPanel();
        jrb_graphTypeLines = new javax.swing.JRadioButton();
        jrb_graphTypeAreasStacked = new javax.swing.JRadioButton();
        jrb_graphTypeDifference = new javax.swing.JRadioButton();
        jSeparator1 = new javax.swing.JSeparator();
        jPanel2 = new javax.swing.JPanel();
        jcb_items0 = new javax.swing.JCheckBox();
        cmb_hosts0 = new javax.swing.JComboBox();
        cmb_tables0 = new javax.swing.JComboBox();
        cmb_columns0 = new javax.swing.JComboBox();
        jt_timestampStart0 = new javax.swing.JTextField();
        jt_timestampEnd0 = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        jcb_items1 = new javax.swing.JCheckBox();
        cmb_hosts1 = new javax.swing.JComboBox();
        cmb_tables1 = new javax.swing.JComboBox();
        cmb_columns1 = new javax.swing.JComboBox();
        jt_timestampStart1 = new javax.swing.JTextField();
        jt_timestampEnd1 = new javax.swing.JTextField();
        jPanel4 = new javax.swing.JPanel();
        jcb_items2 = new javax.swing.JCheckBox();
        cmb_hosts2 = new javax.swing.JComboBox();
        cmb_tables2 = new javax.swing.JComboBox();
        cmb_columns2 = new javax.swing.JComboBox();
        jPanel5 = new javax.swing.JPanel();
        jcb_items3 = new javax.swing.JCheckBox();
        cmb_hosts3 = new javax.swing.JComboBox();
        cmb_tables3 = new javax.swing.JComboBox();
        cmb_columns3 = new javax.swing.JComboBox();
        jPanel6 = new javax.swing.JPanel();
        jcb_items4 = new javax.swing.JCheckBox();
        cmb_hosts4 = new javax.swing.JComboBox();
        cmb_tables4 = new javax.swing.JComboBox();
        cmb_columns4 = new javax.swing.JComboBox();
        jPanel7 = new javax.swing.JPanel();
        jcb_items5 = new javax.swing.JCheckBox();
        cmb_hosts5 = new javax.swing.JComboBox();
        cmb_tables5 = new javax.swing.JComboBox();
        cmb_columns5 = new javax.swing.JComboBox();
        jPanel8 = new javax.swing.JPanel();
        jcb_items6 = new javax.swing.JCheckBox();
        cmb_hosts6 = new javax.swing.JComboBox();
        cmb_tables6 = new javax.swing.JComboBox();
        cmb_columns6 = new javax.swing.JComboBox();
        jPanel1 = new javax.swing.JPanel();
        jb_draw = new javax.swing.JButton();
        jPanel12 = new javax.swing.JPanel();
        jPanel13 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jPanel14 = new javax.swing.JPanel();
        jrb_graphTypeLinesT2 = new javax.swing.JRadioButton();
        jrb_graphTypeAreasStackedT2 = new javax.swing.JRadioButton();
        jSeparator2 = new javax.swing.JSeparator();
        jPanel15 = new javax.swing.JPanel();
        jcb_items1T2 = new javax.swing.JCheckBox();
        cmb_hosts0T2 = new javax.swing.JComboBox();
        jScrollPane1 = new javax.swing.JScrollPane();
        jl_columns0T2 = new javax.swing.JList();
        jt_timestampStart0T2 = new javax.swing.JTextField();
        jt_timestampEnd0T2 = new javax.swing.JTextField();
        jPanel16 = new javax.swing.JPanel();
        jb_drawT2 = new javax.swing.JButton();
        jMenuBar1 = new javax.swing.JMenuBar();
        FileMenu = new javax.swing.JMenu();
        ConnectMenuItem = new javax.swing.JMenuItem();
        ExitMenuItem = new javax.swing.JMenuItem();
        OptionsMenu = new javax.swing.JMenu();
        LookAndFeel = new javax.swing.JMenu();
        jrb_java = new javax.swing.JRadioButtonMenuItem();
        jrb_macintosh = new javax.swing.JRadioButtonMenuItem();
        jrb_motif = new javax.swing.JRadioButtonMenuItem();
        jrb_windows = new javax.swing.JRadioButtonMenuItem();
        HelpMenu = new javax.swing.JMenu();
        AbouMEnuItemt = new javax.swing.JMenuItem();

        jft_timestampMin.setText("jFormattedTextField1");

        getContentPane().setLayout(new java.awt.FlowLayout());

        setTitle("T4Chart");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanel9.setLayout(new javax.swing.BoxLayout(jPanel9, javax.swing.BoxLayout.Y_AXIS));

        jPanel9.setMinimumSize(new java.awt.Dimension(771, 320));
        jPanel9.setPreferredSize(new java.awt.Dimension(780, 330));
        jLabel1.setText("Chart Type");
        jPanel10.add(jLabel1);

        jPanel11.setLayout(new javax.swing.BoxLayout(jPanel11, javax.swing.BoxLayout.X_AXIS));

        jrb_graphTypeLines.setSelected(true);
        jrb_graphTypeLines.setText("Lines");
        jrb_graphTypeLines.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jrb_graphTypeLinesActionPerformed(evt);
            }
        });

        jPanel11.add(jrb_graphTypeLines);

        jrb_graphTypeAreasStacked.setText("Areas stacked");
        jrb_graphTypeAreasStacked.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jrb_graphTypeAreasStackedActionPerformed(evt);
            }
        });

        jPanel11.add(jrb_graphTypeAreasStacked);

        jrb_graphTypeDifference.setText("Difference");
        jrb_graphTypeDifference.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jrb_graphTypeDifferenceActionPerformed(evt);
            }
        });

        jPanel11.add(jrb_graphTypeDifference);

        jPanel10.add(jPanel11);

        jPanel9.add(jPanel10);

        jSeparator1.setPreferredSize(new java.awt.Dimension(0, 10));
        jPanel9.add(jSeparator1);

        jPanel2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jPanel2.setPreferredSize(new java.awt.Dimension(750, 30));
        jcb_items0.setSelected(true);
        jcb_items0.setEnabled(false);
        jPanel2.add(jcb_items0);

        cmb_hosts0.setMinimumSize(new java.awt.Dimension(85, 19));
        cmb_hosts0.setPreferredSize(new java.awt.Dimension(90, 19));
        cmb_hosts0.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_hosts0ActionPerformed(evt);
            }
        });

        jPanel2.add(cmb_hosts0);

        cmb_tables0.setMinimumSize(new java.awt.Dimension(100, 19));
        cmb_tables0.setPreferredSize(new java.awt.Dimension(100, 19));
        cmb_tables0.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_tables0ActionPerformed(evt);
            }
        });

        jPanel2.add(cmb_tables0);

        cmb_columns0.setMinimumSize(new java.awt.Dimension(250, 19));
        cmb_columns0.setPreferredSize(new java.awt.Dimension(250, 19));
        cmb_columns0.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_columns0ActionPerformed(evt);
            }
        });

        jPanel2.add(cmb_columns0);

        jt_timestampStart0.setMinimumSize(new java.awt.Dimension(140, 20));
        jt_timestampStart0.setPreferredSize(new java.awt.Dimension(140, 20));
        jPanel2.add(jt_timestampStart0);

        jt_timestampEnd0.setMinimumSize(new java.awt.Dimension(140, 20));
        jt_timestampEnd0.setPreferredSize(new java.awt.Dimension(140, 20));
        jPanel2.add(jt_timestampEnd0);

        jPanel9.add(jPanel2);

        jPanel3.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jcb_items1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jcb_items1ActionPerformed(evt);
            }
        });

        jPanel3.add(jcb_items1);

        cmb_hosts1.setMinimumSize(new java.awt.Dimension(85, 19));
        cmb_hosts1.setPreferredSize(new java.awt.Dimension(90, 19));
        cmb_hosts1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_hosts1ActionPerformed(evt);
            }
        });

        jPanel3.add(cmb_hosts1);

        cmb_tables1.setMinimumSize(new java.awt.Dimension(100, 19));
        cmb_tables1.setPreferredSize(new java.awt.Dimension(100, 19));
        cmb_tables1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_tables1ActionPerformed(evt);
            }
        });

        jPanel3.add(cmb_tables1);

        cmb_columns1.setMinimumSize(new java.awt.Dimension(250, 19));
        cmb_columns1.setPreferredSize(new java.awt.Dimension(250, 19));
        jPanel3.add(cmb_columns1);

        jt_timestampStart1.setEditable(false);
        jt_timestampStart1.setMinimumSize(new java.awt.Dimension(140, 20));
        jt_timestampStart1.setPreferredSize(new java.awt.Dimension(140, 20));
        jt_timestampStart1.setEnabled(false);
        jPanel3.add(jt_timestampStart1);

        jt_timestampEnd1.setEditable(false);
        jt_timestampEnd1.setMinimumSize(new java.awt.Dimension(140, 20));
        jt_timestampEnd1.setPreferredSize(new java.awt.Dimension(140, 20));
        jt_timestampEnd1.setEnabled(false);
        jPanel3.add(jt_timestampEnd1);

        jPanel9.add(jPanel3);

        jPanel4.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jcb_items2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jcb_items2ActionPerformed(evt);
            }
        });

        jPanel4.add(jcb_items2);

        cmb_hosts2.setMinimumSize(new java.awt.Dimension(85, 19));
        cmb_hosts2.setPreferredSize(new java.awt.Dimension(90, 19));
        cmb_hosts2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_hosts2ActionPerformed(evt);
            }
        });

        jPanel4.add(cmb_hosts2);

        cmb_tables2.setMinimumSize(new java.awt.Dimension(100, 19));
        cmb_tables2.setPreferredSize(new java.awt.Dimension(100, 19));
        cmb_tables2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_tables2ActionPerformed(evt);
            }
        });

        jPanel4.add(cmb_tables2);

        cmb_columns2.setMinimumSize(new java.awt.Dimension(250, 19));
        cmb_columns2.setPreferredSize(new java.awt.Dimension(250, 19));
        jPanel4.add(cmb_columns2);

        jPanel9.add(jPanel4);

        jPanel5.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jcb_items3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jcb_items3ActionPerformed(evt);
            }
        });

        jPanel5.add(jcb_items3);

        cmb_hosts3.setMinimumSize(new java.awt.Dimension(85, 19));
        cmb_hosts3.setPreferredSize(new java.awt.Dimension(90, 19));
        cmb_hosts3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_hosts3ActionPerformed(evt);
            }
        });

        jPanel5.add(cmb_hosts3);

        cmb_tables3.setMinimumSize(new java.awt.Dimension(100, 19));
        cmb_tables3.setPreferredSize(new java.awt.Dimension(100, 19));
        cmb_tables3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_tables3ActionPerformed(evt);
            }
        });

        jPanel5.add(cmb_tables3);

        cmb_columns3.setMinimumSize(new java.awt.Dimension(250, 19));
        cmb_columns3.setPreferredSize(new java.awt.Dimension(250, 19));
        jPanel5.add(cmb_columns3);

        jPanel9.add(jPanel5);

        jPanel6.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jcb_items4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jcb_items4ActionPerformed(evt);
            }
        });

        jPanel6.add(jcb_items4);

        cmb_hosts4.setMinimumSize(new java.awt.Dimension(85, 19));
        cmb_hosts4.setPreferredSize(new java.awt.Dimension(90, 19));
        cmb_hosts4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_hosts4ActionPerformed(evt);
            }
        });

        jPanel6.add(cmb_hosts4);

        cmb_tables4.setMinimumSize(new java.awt.Dimension(100, 19));
        cmb_tables4.setPreferredSize(new java.awt.Dimension(100, 19));
        cmb_tables4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_tables4ActionPerformed(evt);
            }
        });

        jPanel6.add(cmb_tables4);

        cmb_columns4.setMinimumSize(new java.awt.Dimension(250, 19));
        cmb_columns4.setPreferredSize(new java.awt.Dimension(250, 19));
        jPanel6.add(cmb_columns4);

        jPanel9.add(jPanel6);

        jPanel7.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jcb_items5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jcb_items5ActionPerformed(evt);
            }
        });

        jPanel7.add(jcb_items5);

        cmb_hosts5.setMinimumSize(new java.awt.Dimension(85, 19));
        cmb_hosts5.setPreferredSize(new java.awt.Dimension(90, 19));
        cmb_hosts5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_hosts5ActionPerformed(evt);
            }
        });

        jPanel7.add(cmb_hosts5);

        cmb_tables5.setMinimumSize(new java.awt.Dimension(100, 19));
        cmb_tables5.setPreferredSize(new java.awt.Dimension(100, 19));
        cmb_tables5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_tables5ActionPerformed(evt);
            }
        });

        jPanel7.add(cmb_tables5);

        cmb_columns5.setMinimumSize(new java.awt.Dimension(250, 19));
        cmb_columns5.setPreferredSize(new java.awt.Dimension(250, 19));
        cmb_columns5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_columns5ActionPerformed(evt);
            }
        });

        jPanel7.add(cmb_columns5);

        jPanel9.add(jPanel7);

        jPanel8.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jcb_items6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jcb_items6ActionPerformed(evt);
            }
        });

        jPanel8.add(jcb_items6);

        cmb_hosts6.setMinimumSize(new java.awt.Dimension(85, 19));
        cmb_hosts6.setPreferredSize(new java.awt.Dimension(90, 19));
        cmb_hosts6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_hosts6ActionPerformed(evt);
            }
        });

        jPanel8.add(cmb_hosts6);

        cmb_tables6.setMinimumSize(new java.awt.Dimension(100, 19));
        cmb_tables6.setPreferredSize(new java.awt.Dimension(100, 19));
        cmb_tables6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_tables6ActionPerformed(evt);
            }
        });

        jPanel8.add(cmb_tables6);

        cmb_columns6.setMinimumSize(new java.awt.Dimension(250, 19));
        cmb_columns6.setPreferredSize(new java.awt.Dimension(250, 19));
        cmb_columns6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_columns6ActionPerformed(evt);
            }
        });

        jPanel8.add(cmb_columns6);

        jPanel9.add(jPanel8);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setPreferredSize(new java.awt.Dimension(69, 60));
        jb_draw.setText("Draw");
        jb_draw.setMaximumSize(new java.awt.Dimension(59, 50));
        jb_draw.setPreferredSize(new java.awt.Dimension(70, 23));
        jb_draw.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jDrawActionPerformed(evt);
            }
        });

        jPanel1.add(jb_draw, new java.awt.GridBagConstraints());

        jPanel9.add(jPanel1);

        jTabbedPane1.addTab("tab1", jPanel9);

        jPanel12.setLayout(new javax.swing.BoxLayout(jPanel12, javax.swing.BoxLayout.Y_AXIS));

        jLabel2.setText("Chart Type");
        jPanel13.add(jLabel2);

        jPanel14.setLayout(new javax.swing.BoxLayout(jPanel14, javax.swing.BoxLayout.X_AXIS));

        jrb_graphTypeLinesT2.setSelected(true);
        jrb_graphTypeLinesT2.setText("Lines");
        jrb_graphTypeLinesT2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jrb_graphTypeLinesT2ActionPerformed(evt);
            }
        });

        jPanel14.add(jrb_graphTypeLinesT2);

        jrb_graphTypeAreasStackedT2.setText("Areas stacked");
        jrb_graphTypeAreasStackedT2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jrb_graphTypeAreasStackedT2ActionPerformed(evt);
            }
        });

        jPanel14.add(jrb_graphTypeAreasStackedT2);

        jPanel13.add(jPanel14);

        jPanel12.add(jPanel13);

        jSeparator2.setPreferredSize(new java.awt.Dimension(0, 10));
        jPanel12.add(jSeparator2);

        jPanel15.setPreferredSize(new java.awt.Dimension(750, 220));
        jcb_items1T2.setSelected(true);
        jcb_items1T2.setEnabled(false);
        jPanel15.add(jcb_items1T2);

        cmb_hosts0T2.setMinimumSize(new java.awt.Dimension(85, 19));
        cmb_hosts0T2.setPreferredSize(new java.awt.Dimension(90, 19));
        cmb_hosts0T2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmb_hosts0T2ActionPerformed(evt);
            }
        });

        jPanel15.add(cmb_hosts0T2);

        jScrollPane1.setPreferredSize(new java.awt.Dimension(258, 200));
        jScrollPane1.setViewportView(jl_columns0T2);

        jPanel15.add(jScrollPane1);

        jt_timestampStart0T2.setMinimumSize(new java.awt.Dimension(140, 20));
        jt_timestampStart0T2.setPreferredSize(new java.awt.Dimension(140, 20));
        jPanel15.add(jt_timestampStart0T2);

        jt_timestampEnd0T2.setMinimumSize(new java.awt.Dimension(140, 20));
        jt_timestampEnd0T2.setPreferredSize(new java.awt.Dimension(140, 20));
        jPanel15.add(jt_timestampEnd0T2);

        jPanel12.add(jPanel15);

        jPanel16.setLayout(new java.awt.GridBagLayout());

        jPanel16.setPreferredSize(new java.awt.Dimension(69, 60));
        jb_drawT2.setText("Draw");
        jb_drawT2.setMaximumSize(new java.awt.Dimension(59, 50));
        jb_drawT2.setPreferredSize(new java.awt.Dimension(70, 23));
        jb_drawT2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jb_drawT2ActionPerformed(evt);
            }
        });

        jPanel16.add(jb_drawT2, new java.awt.GridBagConstraints());

        jPanel12.add(jPanel16);

        jTabbedPane1.addTab("tab2", jPanel12);

        getContentPane().add(jTabbedPane1);

        FileMenu.setText("File");
        ConnectMenuItem.setText("Connect");
        ConnectMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ConnectMenuItemActionPerformed(evt);
            }
        });

        FileMenu.add(ConnectMenuItem);

        ExitMenuItem.setText("Exit");
        ExitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExitMenuItemActionPerformed(evt);
            }
        });

        FileMenu.add(ExitMenuItem);

        jMenuBar1.add(FileMenu);

        OptionsMenu.setText("Options");
        LookAndFeel.setText("Look and Feel Style");
        jrb_java.setSelected(true);
        jrb_java.setText("Java");
        LookAndFeel.add(jrb_java);

        jrb_macintosh.setText("Macintosh");
        LookAndFeel.add(jrb_macintosh);

        jrb_motif.setText("Motif");
        LookAndFeel.add(jrb_motif);

        jrb_windows.setText("Windows");
        LookAndFeel.add(jrb_windows);

        OptionsMenu.add(LookAndFeel);

        jMenuBar1.add(OptionsMenu);

        HelpMenu.setText("Help");
        AbouMEnuItemt.setText("About");
        AbouMEnuItemt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AbouMEnuItemtActionPerformed(evt);
            }
        });

        HelpMenu.add(AbouMEnuItemt);

        jMenuBar1.add(HelpMenu);

        setJMenuBar(jMenuBar1);

        pack();
    }//GEN-END:initComponents

    private void jb_drawT2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jb_drawT2ActionPerformed
        String startDate = jt_timestampStart0T2.getText();
        String endDate = jt_timestampEnd0T2.getText();
        boolean isStacked = jrb_graphTypeAreasStackedT2.isSelected();
        boolean isDifference = false;
        int nbLines = 0;
        Object selected[] = jl_columns0T2.getSelectedValues();
        nbLines = selected.length;
        String[] lineTitles = new String[nbLines];
        SqlIterator[] iter = new SqlIterator[nbLines];
        for (int i = 0, j =0; i < nbLines; ++i) {
            String nodeName = (String)cmb_hosts[MAX_ITEMS].getSelectedItem();
            String tableName;
            String columnName = (String)selected[i];
            tableName = columnName.substring(1, columnName.indexOf(']'));
            tableName = tableName.replace('.', '_');
            if (tableName.charAt(tableName.length() - 1) == ':')
                tableName = tableName.substring(0, tableName.length() -1);
            tableName = tableName.toLowerCase();
            SqlIterator it =
                Database.getInstance().getItemValues(nodeName, tableName, columnName,
                                                     "sample_time", startDate, endDate);
            
            lineTitles[j] =  nodeName + ": " + columnName;
            iter[j] = it;
            ++j;
        }
        T4ChartChart chart = new T4ChartChart(lineTitles, iter, isStacked, isDifference);
        //        chart.show(true);
        chart.pack();
        RefineryUtilities.centerFrameOnScreen(chart);
        chart.setVisible(true);
        
    }//GEN-LAST:event_jb_drawT2ActionPerformed

    private void jrb_graphTypeAreasStackedT2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jrb_graphTypeAreasStackedT2ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jrb_graphTypeAreasStackedT2ActionPerformed

    private void jrb_graphTypeLinesT2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jrb_graphTypeLinesT2ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jrb_graphTypeLinesT2ActionPerformed

    private void cmb_hosts0T2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_hosts0T2ActionPerformed
        String nodeName;
        Vector resn;
        int i = MAX_ITEMS;
        String oneTableName = "";
        nodeName = (String)cmb_hosts[i].getSelectedItem();
        if (nodeName == null) return;
        resn = Database.getInstance().getTables(nodeName);
        jl_columns0T2.removeAll();
        Vector allColumns = new Vector();
        for (int j = 0; j < resn.size(); ++j){
            String tableName = (String)resn.get(j);
            if (oneTableName == "") oneTableName = tableName; 
            Vector resc = Database.getInstance().getColumns(tableName);
            allColumns.addAll(resc);
        }
        String cname[] = new String[allColumns.size()];
        for (int j = 0; j < allColumns.size(); ++j) {
            String colName = (String)allColumns.get(j);
            cname[j] = colName;
        }
        jl_columns0T2.setListData(cname);
        // use first table to find range timestamp
        resn = Database.getInstance().getDatesRange(nodeName, oneTableName, "sample_time");
        Timestamp tsStart = (Timestamp)resn.get(0);
        Timestamp tsEnd = (Timestamp)resn.get(1);
        jt_timestampStart0T2.setText(tsStart.toString());
        jt_timestampEnd0T2.setText(tsEnd.toString());
        
        
    }//GEN-LAST:event_cmb_hosts0T2ActionPerformed

    private void jcb_items1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jcb_items1ActionPerformed
        if (! jcb_items[1].isSelected())
            for (int i = 2; i < MAX_ITEMS; ++i)
                jcb_items[i].setSelected(false);
    }//GEN-LAST:event_jcb_items1ActionPerformed

    private void jcb_items2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jcb_items2ActionPerformed
        if (jcb_items[2].isSelected())
            for (int i = 1; i < 2; ++i)
                jcb_items[i].setSelected(true);
        else
            for (int i = 3; i < MAX_ITEMS; ++i)
                jcb_items[i].setSelected(false);
    }//GEN-LAST:event_jcb_items2ActionPerformed

    private void jcb_items3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jcb_items3ActionPerformed
        if (jcb_items[3].isSelected())
            for (int i = 1; i < 3; ++i)
                jcb_items[i].setSelected(true);
        else
            for (int i = 4; i < MAX_ITEMS; ++i)
                jcb_items[i].setSelected(false);
    }//GEN-LAST:event_jcb_items3ActionPerformed

    private void jcb_items4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jcb_items4ActionPerformed
        if (jcb_items[4].isSelected())
            for (int i = 1; i < 4; ++i)
                jcb_items[i].setSelected(true);
    }//GEN-LAST:event_jcb_items4ActionPerformed
    
    private void jcb_items5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jcb_items5ActionPerformed
        if (jcb_items[5].isSelected())
            for (int i = 1; i < 5; ++i)
                jcb_items[i].setSelected(true);
        else
            for (int i = 5; i < MAX_ITEMS; ++i)
                jcb_items[i].setSelected(false);
    }//GEN-LAST:event_jcb_items5ActionPerformed
    
    private void jcb_items6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jcb_items6ActionPerformed
        if (jcb_items[6].isSelected())
            for (int i = 1; i < 6; ++i)
                jcb_items[i].setSelected(true);
    }//GEN-LAST:event_jcb_items6ActionPerformed
    
    private void AbouMEnuItemtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AbouMEnuItemtActionPerformed
        new T4ChartAboutDialog(new javax.swing.JFrame(), true, commonVariables).show();
    }//GEN-LAST:event_AbouMEnuItemtActionPerformed

    private void jrb_graphTypeLinesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jrb_graphTypeLinesActionPerformed
        graphTypeSetEnabled(false);
    }//GEN-LAST:event_jrb_graphTypeLinesActionPerformed

    private void jrb_graphTypeAreasStackedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jrb_graphTypeAreasStackedActionPerformed
        graphTypeSetEnabled(false);
    }//GEN-LAST:event_jrb_graphTypeAreasStackedActionPerformed

    private void jrb_graphTypeDifferenceActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jrb_graphTypeDifferenceActionPerformed
        graphTypeSetEnabled(true);
    }//GEN-LAST:event_jrb_graphTypeDifferenceActionPerformed

    private void graphTypeSetEnabled(boolean isDifference) {
        if (isDifference) {
            jt_timestampStart[1].setText(jt_timestampStart[0].getText());
            jt_timestampEnd[1].setText(jt_timestampEnd[0].getText());
        } else {
            jt_timestampStart[1].setText("");
            jt_timestampEnd[1].setText("");
        }
        if (isDifference) jcb_items[1].setSelected(isDifference);
        jcb_items[1].setEnabled(! isDifference);
        jt_timestampStart[1].setEnabled(isDifference);
        jt_timestampStart[1].setEditable(isDifference);
        jt_timestampEnd[1].setEnabled(isDifference);
        jt_timestampEnd[1].setEditable(isDifference);
        for (int i = 2; i < MAX_ITEMS; ++i) {
            if (isDifference) jcb_items[i].setSelected(false);
            jcb_items[i].setEnabled(! isDifference);
            cmb_hosts[i].setEnabled(! isDifference);
            cmb_tables[i].setEnabled(! isDifference);
            cmb_columns[i].setEnabled(! isDifference);
        }
    }
    
    private void cmb_columns6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_columns6ActionPerformed
        cmb_columnsActionPerformed(6, evt);
    }//GEN-LAST:event_cmb_columns6ActionPerformed

    private void cmb_tables6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_tables6ActionPerformed
        cmb_tablesActionPerformed(6, evt);
    }//GEN-LAST:event_cmb_tables6ActionPerformed

    private void cmb_hosts6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_hosts6ActionPerformed
        cmb_hostsActionPerformed(6, evt);
    }//GEN-LAST:event_cmb_hosts6ActionPerformed

    private void cmb_columns5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_columns5ActionPerformed
        cmb_columnsActionPerformed(5, evt);
    }//GEN-LAST:event_cmb_columns5ActionPerformed

    private void cmb_tables5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_tables5ActionPerformed
        cmb_tablesActionPerformed(5, evt);
    }//GEN-LAST:event_cmb_tables5ActionPerformed

    private void cmb_hosts5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_hosts5ActionPerformed
        cmb_hostsActionPerformed(5, evt);
    }//GEN-LAST:event_cmb_hosts5ActionPerformed

    private void cmb_tables4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_tables4ActionPerformed
        cmb_tablesActionPerformed(4, evt);
    }//GEN-LAST:event_cmb_tables4ActionPerformed
    
    private void cmb_tables3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_tables3ActionPerformed
        cmb_tablesActionPerformed(3, evt);
    }//GEN-LAST:event_cmb_tables3ActionPerformed

    private void cmb_tables2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_tables2ActionPerformed
        cmb_tablesActionPerformed(2, evt);
    }//GEN-LAST:event_cmb_tables2ActionPerformed

    private void cmb_tables1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_tables1ActionPerformed
        cmb_tablesActionPerformed(1, evt);
    }//GEN-LAST:event_cmb_tables1ActionPerformed

    private void cmb_hosts4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_hosts4ActionPerformed
        cmb_hostsActionPerformed(4, evt);
    }//GEN-LAST:event_cmb_hosts4ActionPerformed

    private void cmb_hosts3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_hosts3ActionPerformed
        cmb_hostsActionPerformed(3, evt);
    }//GEN-LAST:event_cmb_hosts3ActionPerformed

    private void cmb_hosts2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_hosts2ActionPerformed
        cmb_hostsActionPerformed(2, evt);
    }//GEN-LAST:event_cmb_hosts2ActionPerformed

    private void cmb_hosts1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_hosts1ActionPerformed
        cmb_hostsActionPerformed(1, evt);
    }//GEN-LAST:event_cmb_hosts1ActionPerformed
    
    private void cmb_columns0ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_columns0ActionPerformed
        cmb_columnsActionPerformed(0, evt);
    }//GEN-LAST:event_cmb_columns0ActionPerformed
 
    private void cmb_columnsActionPerformed(int i, java.awt.event.ActionEvent evt) {
        String nodeName = (String)cmb_hosts[i].getSelectedItem();
        String tableName = (String)cmb_tables[i].getSelectedItem();
        String colName;
        Vector res;
        colName = (String)cmb_columns[i].getSelectedItem();
        if (nodeName == null || tableName == null || colName == null) return;
        
        if (i == 0 && evalMinMax) {
            evalMinMax = false;
            res = Database.getInstance().getDatesRange(nodeName, tableName, "sample_time");
            Timestamp tsStart = (Timestamp)res.get(0);
            Timestamp tsEnd = (Timestamp)res.get(1);
            jt_timestampStart[0].setText(tsStart.toString());
            jt_timestampEnd[0].setText(tsEnd.toString());
            //        js_timestampMin.setMinimum((int)tsEnd.getTime());
            //        js_timestampMin.setMaximum((int)tsEnd.getTime());
        }
    }
    
    
    private void cmb_tables0ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_tables0ActionPerformed
        cmb_tablesActionPerformed(0, evt);
    }//GEN-LAST:event_cmb_tables0ActionPerformed

    private void cmb_tablesActionPerformed(int i, java.awt.event.ActionEvent evt) {
        String str;
        Vector res;
        str = (String)cmb_tables[i].getSelectedItem();
        if (str == null) return;
        cmb_columns[i].removeAllItems();
        res = Database.getInstance().getColumns(str);
        for (int j = 0; j < res.size(); ++j) {
            String colName = (String)res.get(j);
            cmb_columns[i].addItem(colName);
        }
    }    
    
    private void cmb_hosts0ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmb_hosts0ActionPerformed
        cmb_hostsActionPerformed(0, evt);
    }//GEN-LAST:event_cmb_hosts0ActionPerformed

    private void cmb_hostsActionPerformed(int i, java.awt.event.ActionEvent evt) {
        String nodeName;
        Vector res;
        nodeName = (String)cmb_hosts[i].getSelectedItem();
        if (nodeName == null) return;
        if (i == 0) evalMinMax = true;
        res = Database.getInstance().getTables(nodeName);
        cmb_tables[i].removeAllItems();
        for (int j = 0; j < res.size(); ++j){
            String tableName = (String)res.get(j);
            if (! "node".equals(tableName)) {
                cmb_tables[i].addItem(tableName);
            }
        }
    }
        
    private void jDrawActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jDrawActionPerformed
        String startDate = jt_timestampStart[0].getText();
        String endDate = jt_timestampEnd[0].getText();
        boolean isStacked = jrb_graphTypeAreasStacked.isSelected();
        boolean isDifference = jrb_graphTypeDifference.isSelected();
        int nbLines = 0;
        for (int i = 0; i < MAX_ITEMS; ++i) {
            if (jcb_items[i].isSelected()) ++nbLines;
        }
        String[] lineTitles = new String[nbLines];
        SqlIterator[] iter = new SqlIterator[nbLines];
        for (int i = 0, j =0; i < MAX_ITEMS; ++i) {
            if (jcb_items[i].isSelected()) {
                String nodeName = (String)cmb_hosts[i].getSelectedItem();
                String tableName = (String)cmb_tables[i].getSelectedItem();
                String columnName = (String)cmb_columns[i].getSelectedItem();
                if (isDifference) {
                    startDate = jt_timestampStart[i].getText();
                    endDate = jt_timestampEnd[i].getText();
                }
                SqlIterator it =
                    Database.getInstance().getItemValues(nodeName, tableName, columnName,
                                                         "sample_time", startDate, endDate);
                
                lineTitles[j] =  nodeName + ": " + columnName;
                iter[j] = it;
                ++j;
            }
        }
        T4ChartChart chart = new T4ChartChart(lineTitles, iter, isStacked, isDifference);
        //        chart.show(true);
        chart.pack();
        RefineryUtilities.centerFrameOnScreen(chart);
        chart.setVisible(true);    
    }//GEN-LAST:event_jDrawActionPerformed
        
    private void ConnectMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ConnectMenuItemActionPerformed
        DoConnect();
    }//GEN-LAST:event_ConnectMenuItemActionPerformed
    
    private void DoConnect() {
        new T4ConnectDialog(new javax.swing.JFrame(), true, commonVariables).show();
        
        Vector res;
        
        for (int j = 0; j < MAX_ITEMS + 1; ++j) cmb_hosts[j].removeAllItems();
        for (int j = 0; j < MAX_ITEMS; ++j) cmb_tables[j].removeAllItems();
        for (int j = 0; j < MAX_ITEMS; ++j) cmb_columns[j].removeAllItems();
        jl_columns0T2.removeAll();
        res = Database.getInstance().getNodes();
        for (int i = 0; i < res.size(); ++i) {
            String nodeName = (String)res.get(i);
            for (int j = 0; j < MAX_ITEMS + 1; ++j) cmb_hosts[j].addItem(nodeName);
        }
    }
    
    private void ExitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExitMenuItemActionPerformed
        System.exit(0);
    }//GEN-LAST:event_ExitMenuItemActionPerformed
            
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    public void setJMenuBar(javax.swing.JMenuBar jMenuBar) {
        super.setJMenuBar(jMenuBar);
    }
    
    public javax.swing.JRootPane getRootPane() {
        javax.swing.JRootPane retValue;
        
        retValue = super.getRootPane();
        return retValue;
    }
    
    public Container getRootComponent() {
        //  	if(isApplet())
        //  	    return applet;
        //  	else
        //  	    return frame;
        return T4Chart.this;
    }
    
    /**
     * Switch between the Windows, Motif, Mac, and the Java Look and Feel
     */
    class ToggleUIListener implements ItemListener {
        public void itemStateChanged(ItemEvent e) {
            Component root = getRootComponent();
            root.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
            JRadioButtonMenuItem rb = (JRadioButtonMenuItem) e.getSource();

            try {
                if(rb.isSelected()
                && rb.getText().equals("Windows")) {
                    _currentUI = "Windows";
                    UIManager.setLookAndFeel(K_windowsClassName);
                    SwingUtilities.updateComponentTreeUI(getRootComponent());
                } else if(rb.isSelected()
                && rb.getText().equals("Macintosh")) {
                    _currentUI = "Macintosh";
                    UIManager.setLookAndFeel(K_macClassName);
                    SwingUtilities.updateComponentTreeUI(getRootComponent());
                } else if(rb.isSelected()
                && rb.getText().equals("Motif")) {
                    _currentUI = "Motif";
                    UIManager.setLookAndFeel(K_motifClassName);
                    SwingUtilities.updateComponentTreeUI(getRootComponent());
                } else if(rb.isSelected()
                && rb.getText().equals("Java")) {
                    _currentUI = "Metal";
                    // javax.swing.plaf.metal.MetalLookAndFeel.setCurrentTheme(
                    //      new javax.swing.plaf.metal.DefaultMetalTheme());
                    UIManager.setLookAndFeel(K_metalClassName);
                    SwingUtilities.updateComponentTreeUI(getRootComponent());
                }
            } catch (UnsupportedLookAndFeelException exc) {
                // Error - unsupported L&F
                rb.setEnabled(false);
                System.err.println("Unsupported LookAndFeel: " + rb.getText());
                
                // Set L&F to JLF
                try {
                    _currentUI = "Metal";
                    _metalMenuItem.setSelected(true);
                    UIManager.setLookAndFeel(
                    UIManager.getCrossPlatformLookAndFeelClassName());
                    //  		    tabPlacement.setEnabled(true);
                    SwingUtilities.updateComponentTreeUI(getRootComponent());
                } catch (Exception exc2) {
                    System.err.println("Could not load LookAndFeel: " + exc2);
                    exc2.printStackTrace();
                }
            } catch (Exception exc) {
                rb.setEnabled(false);
                System.err.println("Could not load LookAndFeel: " + rb.getText());
                exc.printStackTrace();
            }
            
            root.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        }
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem AbouMEnuItemt;
    private javax.swing.JMenuItem ConnectMenuItem;
    private javax.swing.JMenuItem ExitMenuItem;
    private javax.swing.JMenu FileMenu;
    private javax.swing.JMenu HelpMenu;
    private javax.swing.JMenu LookAndFeel;
    private javax.swing.JMenu OptionsMenu;
    private javax.swing.ButtonGroup bg_LookAndFeel;
    private javax.swing.ButtonGroup bg_graphType;
    private javax.swing.ButtonGroup bg_graphTypeT2;
    private javax.swing.JComboBox cmb_columns0;
    private javax.swing.JComboBox cmb_columns1;
    private javax.swing.JComboBox cmb_columns2;
    private javax.swing.JComboBox cmb_columns3;
    private javax.swing.JComboBox cmb_columns4;
    private javax.swing.JComboBox cmb_columns5;
    private javax.swing.JComboBox cmb_columns6;
    private javax.swing.JComboBox cmb_hosts0;
    private javax.swing.JComboBox cmb_hosts0T2;
    private javax.swing.JComboBox cmb_hosts1;
    private javax.swing.JComboBox cmb_hosts2;
    private javax.swing.JComboBox cmb_hosts3;
    private javax.swing.JComboBox cmb_hosts4;
    private javax.swing.JComboBox cmb_hosts5;
    private javax.swing.JComboBox cmb_hosts6;
    private javax.swing.JComboBox cmb_tables0;
    private javax.swing.JComboBox cmb_tables1;
    private javax.swing.JComboBox cmb_tables2;
    private javax.swing.JComboBox cmb_tables3;
    private javax.swing.JComboBox cmb_tables4;
    private javax.swing.JComboBox cmb_tables5;
    private javax.swing.JComboBox cmb_tables6;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JPanel jPanel16;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JButton jb_draw;
    private javax.swing.JButton jb_drawT2;
    private javax.swing.JCheckBox jcb_items0;
    private javax.swing.JCheckBox jcb_items1;
    private javax.swing.JCheckBox jcb_items1T2;
    private javax.swing.JCheckBox jcb_items2;
    private javax.swing.JCheckBox jcb_items3;
    private javax.swing.JCheckBox jcb_items4;
    private javax.swing.JCheckBox jcb_items5;
    private javax.swing.JCheckBox jcb_items6;
    private javax.swing.JFormattedTextField jft_timestampMin;
    private javax.swing.JList jl_columns0T2;
    private javax.swing.JRadioButton jrb_graphTypeAreasStacked;
    private javax.swing.JRadioButton jrb_graphTypeAreasStackedT2;
    private javax.swing.JRadioButton jrb_graphTypeDifference;
    private javax.swing.JRadioButton jrb_graphTypeLines;
    private javax.swing.JRadioButton jrb_graphTypeLinesT2;
    private javax.swing.JRadioButtonMenuItem jrb_java;
    private javax.swing.JRadioButtonMenuItem jrb_macintosh;
    private javax.swing.JRadioButtonMenuItem jrb_motif;
    private javax.swing.JRadioButtonMenuItem jrb_windows;
    private javax.swing.JSlider js_timestampMin;
    private javax.swing.JTextField jt_timestampEnd0;
    private javax.swing.JTextField jt_timestampEnd0T2;
    private javax.swing.JTextField jt_timestampEnd1;
    private javax.swing.JTextField jt_timestampStart0;
    private javax.swing.JTextField jt_timestampStart0T2;
    private javax.swing.JTextField jt_timestampStart1;
    // End of variables declaration//GEN-END:variables
    
}
