package T4Chart;
/*
 * T4Main.java
 *
 * Created on 10 mars 2004, 09:37
 */

import javax.swing.*;
import java.util.*;
import org.jfree.ui.RefineryUtilities;

import T4Chart.*;
/**
 *
 * @author  JF
 */
public class T4Main implements T4ChartConstants {
    
    static private  JFrame frame;
    
    static private ResourceBundle resources;
    
    static private T4ChartVariables chartVariables;
    
    static {
        resources = ResourceBundle.getBundle("T4Chart.T4Chart", Locale.getDefault());
        chartVariables = new T4ChartVariables();
    }
    
    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {
        //Make sure we have nice window decorations.
        // Frame.setDefaultLookAndFeelDecorated(true);
        
        //Create and set up the window.
        frame = new T4Chart(chartVariables);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        //Create and set up the content pane.
/*
    JComponent newContentPane = new FocusConceptsDemo();
    newContentPane.setOpaque(true); //content panes must be opaque
    frame.setContentPane(newContentPane);
 */
        //Display the window.
        frame.pack();
        RefineryUtilities.centerFrameOnScreen(frame);
        frame.setVisible(true);
    }

    static String getResource(String key) {
        return (resources == null) ? null : resources.getString(key);
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            UIManager.setLookAndFeel(
//            UIManager.getSystemLookAndFeelClassName());
            // If you want the Java L&F instead, comment out the above line and
            // uncomment the following:
             UIManager.getCrossPlatformLookAndFeelClassName());
        } catch (Exception e) {
            e.printStackTrace();
        }
        
       //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });
    }
 }
